#ifndef __WEPGEN_H
#define __WEPGEN_H
/*
 * keygen.c
 *	WEP Key Generators
 *
 * This program generates WEP keys using de facto standard key
 * generators for 40 and 128 bit keys.
 *
 * Link against OpenSSL's libcrypto.a
 *
 * I place this code in the public domain.
 * May 2001, Tim Newsham
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include "md5.h"

#define WEPKEYSIZE      	5
#define WEPSTRONGKEYSIZE	13
#define WEPKEYS         	4
#define WEPKEYSTORE     	(WEPKEYSIZE * WEPKEYS)

class wepgen {

    public :
        //
        // Also indicates the size of the resulting
        // strings after md5/bit bashing (dep. on 
        // algo. called).
        //
        enum WepType {
             Wep_TypeUnknown = 0
            ,Wep_1x64b  = 5
            ,Wep_4x64b  = 20
            ,Wep_1x128b = 13
            ,Wep_4x128b = 52
            } ;

    private :
        enum WepMeta {
             Wep_KeySize        = 5
            ,Wep_StrongKeySize  = 13
            ,Wep_Keys           = 4
            ,WepKey_Store       = Wep_KeySize * Wep_Keys
            } ;

    public : 
        wepgen() ;
        wepgen( const caddr_t&, enum WepType ) ;

    public :
        void toStdout() const ;

    private :
        void wep_seedkeygen(int);
        void wep_keygen128(const caddr_t&);
        void wep_keygen40(const caddr_t&);

    private :
        unsigned int Type ;
        unsigned char Octets[52] ;
} ;

#endif // __WEPGEN_H
